/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.javacodegeeks.completablefutureexample;

import java.util.concurrent.CompletableFuture;

/**
 *
 * @author omozegieaziegbe
 */
public class CompletableFutureExample {

    public static void main(String[] args) {
        CompletableFuture<Integer> future = CompletableFuture.supplyAsync(() -> 42); // Asynchronously compute 42

        future.thenApply(result -> result * 2) // Double the result
                .thenAccept(finalResult -> System.out.println("Result: " + finalResult))
                .exceptionally(ex -> {
                    System.err.println("Exception: " + ex);
                    return null;
                });
        
// Wait for the CompletableFuture to complete
        try {
            future.join(); // Block until the CompletableFuture is done
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        System.out.println("Main thread continues to execute other tasks...");
    }
}
