/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.javacodegeeks.futureexample;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

/**
 *
 * @author omozegieaziegbe
 */
public class FutureExample {

   public static void main(String[] args) {
        // Create an ExecutorService with a single thread
        ExecutorService executorService = Executors.newSingleThreadExecutor();

        // Submit a task to the ExecutorService
        Future<Integer> future = executorService.submit(() -> {
            Thread.sleep(1000); // Simulate a time-consuming operation
            return 9; // The result of the computation
        });

        // Continue with other tasks while the above task is running

        // Check if the task is done
        if (future.isDone()) {
            try {
                // Retrieve the result when the task is complete
                Integer result = future.get();
                System.out.println("Task completed. Result: " + result);
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        } else {
            System.out.println("Task is not yet complete. Continuing with other tasks...");
        }

        // Shutdown the ExecutorService when done
        executorService.shutdown();
    }
}
